<template>
  <div class="testStyle" no-gutters>
    <!-- BARRA TOPO -->
    <section class="primary topBar">
      <div class="contentTopBar">
        <span class="headline text-uppercase test--text">UDESC</span>
        <v-divider class="mx-2" vertical color="white" />
        <span class="headline text-uppercase white--text font-weight-light">Polvo</span>
        <span
          class="headline white--text font-weight-light pl-2"
          style="font-size: 1.2rem !important"
          >- {{ onlyView ? 'Modo de visualização' : 'Desempenho Avaliação' }}
        </span>
      </div>
      <v-spacer />
      <v-btn outlined color="white" class="mr-6" @click="handleClose">Fechar</v-btn>
    </section>
    <section class="contentStyleTest">
      <!-- MENU ESQUERDA -->
      <div class="leftStyle">
        <!-- MENU QUESTOES PROVA -->
        <span>
          <!-- Visão prova -->
          <v-subheader v-if="onlyView">
            <v-row no-gutters align="center" justify="center">
              <v-icon class="pr-2">mdi-eye</v-icon>Modo visualização de prova
            </v-row>
          </v-subheader>

          <!-- Estatisticas prova -->
          <v-subheader v-if="!onlyView && students.length > 0" class="mb-3">
            <v-row no-gutters align="center" justify="center">
              <v-icon class="pr-2">mdi-file-document-outline</v-icon><b>Ver prova de:</b>
            </v-row>
          </v-subheader>

          <v-subheader v-if="!onlyView && students.length > 0">
            <v-row no-gutters align="center" justify="center" class="mt-2">
              <v-select
                :disabled="students.length == 0"
                prepend-icon="mdi-account"
                :items="students"
                v-model="analysisStudent.idTest"
                item-text="student.name"
                item-value="id"
                label="Selecione o aluno"
              ></v-select>
            </v-row>
          </v-subheader>
          <v-subheader v-if="onlyView" class="primary--text mt-0 mb-1">
            <b>{{ activeTest.title }} (Gabarito)</b>
          </v-subheader>

          <v-subheader v-else class="primary--text mt-2">
            <b>{{ activeTest.title }}</b>
            <v-tooltip color="primary" bottom nudge-bottom="-8">
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" small class="ml-2" color="primary" @click="showRightAnswers"
                  >mdi-eye
                </v-icon>
              </template>
              <span>Ver Gabarito</span>
            </v-tooltip>
          </v-subheader>

          <v-subheader v-if="activeGabarito && !onlyView" class="mt-n3 mb-1">
            (Vendo gabarito)
          </v-subheader>

          <!-- // mensagem quando tem aluno selecionado -->
          <v-subheader
            v-if="!activeGabarito && !onlyView && analysisStudent.idTest"
            class="mt-n3 mb-1"
          >
            <span>
              Vendo prova de <b>{{ this.analysisStudent.info.name }}</b>
            </span>
          </v-subheader>

          <v-subheader
            v-if="!activeGabarito && !onlyView && analysisStudent.idTest"
            class="mt-n3 mb-1"
          >
            <span> <b>Nota:</b> {{ this.analysisStudent.grade }}/10 </span>
          </v-subheader>
          <!-- // FIM mensagem quando tem aluno selecionado -->

          <v-list dense class="pt-0">
            <v-list-item-group color="primary" v-model="activeQuestion" mandatory>
              <v-list-item v-for="(question, index) in activeTest.questions" :key="index">
                <v-list-item-action class="mr-5">
                  <v-icon color="primary" small>mdi-circle-medium</v-icon>
                </v-list-item-action>
                <v-list-item-content>
                  <v-list-item-title v-text="`Questão ${index + 1}`" />
                </v-list-item-content>
              </v-list-item>
            </v-list-item-group>
          </v-list>
        </span>
      </div>

      <!-- MENU DIREITA -->
      <div class="rightStyle">
        <!-- VISÃO PROVA -->
        <span v-if="activeTest.questions.length > 0">
          <v-row no-gutters align="center" justify="center" class="mb-4">
            <span class="primary--text" style="font-size:1.3rem">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-file-document</v-icon
              ><b>{{ activeTest.title }}</b>
            </span>
          </v-row>

          <!-- Menu superior ver estatisticas -->
          <v-row
            v-if="!onlyView"
            no-gutters
            align="center"
            justify="center"
            style="max-width: 95%"
            class="mb-6"
          >
            <v-select
              style="max-width:275px"
              class="mr-4"
              prepend-icon="mdi-account-group-outline"
              :items="viewClassesTests"
              v-model="selectedClass"
              item-text="name"
              item-value="id"
              label="Selecione a classe"
            ></v-select>
            <v-btn :disabled="students.length == 0" small outlined @click="showStatistics">
              <v-icon class="pr-2" color="primary">mdi-chart-bar</v-icon>
              Estatísticas da turma
            </v-btn>
          </v-row>

          <!-- Estatisticas -->
          <v-row v-if="!onlyView && statisticMode" no-gutters justify="center">
            <v-card style="width: 80%" class="pa-6" elevation="3">
              <v-row v-if="students.length == 0" class="mb-4" justify="center">
                <span>Por favor, <b>selecione uma classe</b> para ver as estatísticas.</span>
              </v-row>
              <v-row v-if="students.length > 0" class="mb-3" style="font-size:0.95rem">
                <v-col align="center" cols="12" sm="12" md="6" lg="6" xl="6">
                  <v-card outlined class="pa-4">
                    <h2>
                      <v-icon large class="pb-1">mdi-upload</v-icon>
                      Envios
                    </h2>
                    <br />
                    <span>
                      <b>Total de provas submetidas:</b>
                      {{ students.length }}
                    </span>
                    <br />
                    <span>
                      <b>Total de alunos na turma:</b>
                      {{ selectedClassLength }}
                    </span>
                    <br />
                    <span>
                      <b>Porcentagem de provas submetidas:</b>
                      {{ ((students.length / selectedClassLength) * 100).toFixed(2) }}%
                    </span>
                    <br />
                  </v-card>
                </v-col>

                <v-col align="center" cols="12" sm="12" md="6" lg="6" xl="6">
                  <v-card outlined class="pa-4">
                    <h2>
                      <v-icon large class="pb-1">mdi-chart-line</v-icon>
                      Notas
                    </h2>
                    <br />
                    <span>
                      <b>Maior nota obtida:</b>
                      {{ classGrade.max }}
                    </span>
                    <br />
                    <span>
                      <b>Menor nota obtida:</b>
                      {{ classGrade.min }}
                    </span>
                    <br />
                    <span>
                      <b>Média das notas obtidas:</b>
                      {{ classGrade.average }}
                    </span>
                    <br />
                  </v-card>
                </v-col>

                <v-col cols="12" align="center">
                  <h2>
                    <v-icon large class="pb-1 pr-2">mdi-file-document-outline</v-icon>Lista de notas
                  </h2>
                  <v-data-table
                    disable-sort
                    :headers="headers"
                    :items="students"
                    :items-per-page="-1"
                    class="elevation-0 mt-4"
                    hide-default-footer
                  >
                    <template v-slot:[`item.student.name`]="{ item }">
                      <section>
                        <span>{{ item.student.name }} {{ item.student.surname }}</span>
                      </section>
                    </template>
                    <template v-slot:[`item.grade`]="{ item }">
                      {{ item.grade }}
                    </template>
                  </v-data-table>
                </v-col>
              </v-row>
            </v-card>
          </v-row>

          <!-- LAYOUT QUESTOES -->
          <v-row v-if="!statisticMode" no-gutters justify="center">
            <v-card style="width: 80%" class="pa-8">
              <v-row class="mb-4">
                <b>
                  Questão {{ activeQuestion + 1 }} -
                  {{ activeTest.questions[activeQuestion].body }} ({{
                    activeTest.questions[activeQuestion].weight
                  }}
                  pontos)
                </b>
              </v-row>
              <!-- VERDADEIRO OU FALSO -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'trueOrFalse'">
                <v-row
                  class="mb-1 grey--text text--darken-3"
                  v-for="(answer, index) in activeTest.questions[activeQuestion].answers"
                  :key="index"
                  no-gutters
                >
                  <v-col style="max-width: 90px; display: flex; align-self: center">
                    <span class="pr-2">{{ orderQuestion[index] }}</span>
                    <v-select
                      disabled
                      v-model="answer.userAnswer"
                      class="ma-0 pa-0"
                      outlined
                      dense
                      flat
                      :items="trueFalse"
                      item-text="label"
                      item-value="value"
                    />
                  </v-col>
                  <v-col class="mt-2 ml-3" style="display:flex; align-self: start">
                    {{ answer.text }}
                    <!-- icone questao certa ou errada -->
                    <v-icon
                      class="pb-1 pl-2"
                      v-if="verifyIcon(answer.text, activeTest.questions[activeQuestion]._id)"
                      :style="
                        showIcons(
                          answer,
                          answer.userAnswer,
                          activeTest.questions[activeQuestion]._id,
                          'trueOrFalse'
                        )
                          ? 'color: green !important'
                          : 'color: red !important'
                      "
                      small
                    >
                      {{
                        showIcons(
                          answer,
                          answer.userAnswer,
                          activeTest.questions[activeQuestion]._id,
                          'trueOrFalse'
                        )
                          ? 'mdi-check'
                          : 'mdi-close'
                      }}
                    </v-icon>

                    <!-- FIM icone questao certa ou errada -->
                  </v-col>
                </v-row>
              </span>
              <!-- DISSERTATIVA -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'dissertation'">
                <v-row
                  :class="
                    showIcons(
                      null,
                      activeTest.questions[activeQuestion].userAnswer,
                      activeTest.questions[activeQuestion]._id,
                      'dissertation'
                    )
                      ? 'green lighten-4 px-4'
                      : 'red lighten-4 px-4'
                  "
                >
                  <v-text-field
                    disabled
                    label="Resposta"
                    v-model="activeTest.questions[activeQuestion].userAnswer"
                  ></v-text-field>
                </v-row>
              </span>
              <!-- OBJETIVA/MULTIPLA ESCOLHA -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'objective'">
                <v-radio-group v-model="activeTest.questions[activeQuestion].userAnswer" disabled>
                  <v-radio
                    v-for="(n, index) in activeTest.questions[activeQuestion].answers"
                    :key="index"
                    :label="`${orderQuestion[index]} ${n.text}`"
                    :value="n.text"
                  >
                    <template v-slot:label>
                      <div class="grey--text text--darken-3">
                        {{ orderQuestion[index] }} {{ n.text }}
                        <!-- icone questao certa ou errada -->
                        <v-icon
                          v-if="verifyIcon(n.text, activeTest.questions[activeQuestion]._id)"
                          :style="
                            showIcons(
                              n.text,
                              activeTest.questions[activeQuestion].userAnswer,
                              activeTest.questions[activeQuestion]._id,
                              'objective'
                            )
                              ? 'color: green !important'
                              : 'color: red !important'
                          "
                          class="pb-1 pl-2"
                          small
                        >
                          {{
                            showIcons(
                              n.text,
                              activeTest.questions[activeQuestion].userAnswer,
                              activeTest.questions[activeQuestion]._id,
                              'objective'
                            )
                              ? 'mdi-check'
                              : 'mdi-close'
                          }}
                        </v-icon>

                        <!-- FIM icone questao certa ou errada -->
                      </div>
                    </template></v-radio
                  >
                </v-radio-group>
              </span>
              <!-- MULTIPLA ESCOLHA MULTI VALORES -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'multipleChoice'">
                <v-row
                  class="mb-1 grey--text text--darken-3"
                  v-for="(answer, index) in activeTest.questions[activeQuestion].answers"
                  :key="index"
                  no-gutters
                >
                  <v-col style="max-width: 60px; display: flex; align-self: center">
                    <span class="pr-2">{{ orderQuestion[index] }}</span>
                    <v-checkbox
                      disabled
                      v-model="answer.userAnswer"
                      item-value="value"
                      class="ma-0 pa-0"
                    />
                  </v-col>
                  <v-col class="ml-0" style="display:flex; align-self: start">
                    {{ answer.text }}
                    <!-- icone questao certa ou errada -->
                    <v-icon
                      class="pb-1 pl-2"
                      v-if="verifyIcon(answer.text, activeTest.questions[activeQuestion]._id)"
                      :style="
                        showIcons(
                          answer,
                          answer.userAnswer,
                          activeTest.questions[activeQuestion]._id,
                          'multipleChoice'
                        )
                          ? 'color: green !important'
                          : 'color: red !important'
                      "
                      small
                    >
                      {{
                        showIcons(
                          answer,
                          answer.userAnswer,
                          activeTest.questions[activeQuestion]._id,
                          'multipleChoice'
                        )
                          ? 'mdi-check'
                          : 'mdi-close'
                      }}
                    </v-icon>

                    <!-- FIM icone questao certa ou errada -->
                  </v-col>
                </v-row>
              </span>
              <!-- SOMATORIO -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'summation'">
                <v-row
                  class="mb-1 grey--text text--darken-3"
                  v-for="(answer, index) in activeTest.questions[activeQuestion].answers"
                  :key="index"
                  no-gutters
                >
                  <v-col style="display: flex; align-self: center">
                    <span class="pr-2">{{ Math.pow(2, index) }}.</span>
                    <v-checkbox
                      disabled
                      v-model="answer.userAnswer"
                      item-value="value"
                      class="ma-0 pa-0"
                    />
                    {{ answer.text }}
                    <!-- icone questao certa ou errada -->
                    <v-icon
                      class="pb-1 pl-2"
                      v-if="verifyIcon(answer.text, activeTest.questions[activeQuestion]._id)"
                      :style="
                        showIcons(
                          answer,
                          answer.userAnswer,
                          activeTest.questions[activeQuestion]._id,
                          'summation'
                        )
                          ? 'color: green !important'
                          : 'color: red !important'
                      "
                      small
                    >
                      {{
                        showIcons(
                          answer,
                          answer.userAnswer,
                          activeTest.questions[activeQuestion]._id,
                          'summation'
                        )
                          ? 'mdi-check'
                          : 'mdi-close'
                      }}
                    </v-icon>
                    <!-- FIM icone questao certa ou errada -->
                  </v-col>
                </v-row>
                <v-row style="display: flex" class="mt-7">
                  <span class="pt-2 pr-4">
                    <b>Sua resposta:</b>
                    {{ activeTest.questions[activeQuestion].userAnswer }}
                  </span>
                </v-row>
              </span>
              <v-row v-if="analysisStudent.idTest" class="mt-2 mr-n4">
                <span
                  ><b>Nota obtida na questão:</b>
                  {{
                    showGradeAnswer(
                      this.analysisStudent.idTest,
                      activeTest.questions[activeQuestion]._id
                    )
                  }}
                  ({{
                    (
                      showGradeAnswer(
                        this.analysisStudent.idTest,
                        activeTest.questions[activeQuestion]._id
                      ) / activeTest.questions[activeQuestion].weight
                    ).toFixed(3) * 100
                  }}%)</span
                >
              </v-row>
            </v-card>
          </v-row>
          <v-row no-gutters justify="center" class="mt-5">
            <v-card color="transparent" elevation="0" style="width: 80%" align="center">
              <v-btn
                v-if="!statisticMode"
                :disabled="activeQuestion == 0"
                outlined
                class="mr-4"
                elevation="0"
                color="primary"
                @click="activeQuestion--"
                >Anterior</v-btn
              >
              <v-btn
                v-if="activeQuestion !== activeTest.questions.length - 1 && !statisticMode"
                outlined
                elevation="0"
                color="primary"
                @click="activeQuestion++"
                >Próxima</v-btn
              >
            </v-card>
          </v-row>
        </span>
      </div>
    </section>
  </div>
</template>

<script>
import Cam from '../camUser.vue'
import Teacher from '../../../servicesEhq/req/teacher'

export default {
  name: 'ShowResult',
  props: {
    test: { type: Object, default: () => {} },
    userRole: { type: String, default: '' },
    onlyView: { type: Boolean, default: false },
    classes: { type: Array, default: () => [] },
  },
  components: { Cam },
  data: () => ({
    activeQuestion: 0,
    activeTest: {},
    orderQuestion: [
      'a)',
      'b)',
      'c)',
      'd)',
      'e)',
      'f)',
      'g)',
      'h)',
      'i)',
      'j)',
      'k)',
      'l)',
      'm)',
      'n)',
    ],
    trueFalse: [
      { label: 'V', value: true },
      { label: 'F', value: false },
    ],
    alert: {
      status: false,
      icon: 'mdi-alert',
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    finishTest: false,
    model: { text: 'Tomas de Aquino', userAnswer: '' },
    viewClassesTests: [], // separa por TURMA
    selectedClass: '',
    selectedClassLength: '',
    classGrade: { min: 0, max: 0, average: 0 },
    students: [],
    analysisStudent: { idTest: '', answers: [], info: '', grade: '' },
    gabarito: '',
    activeGabarito: true,
    statisticMode: false,
    headers: [
      {
        text: 'Nome',
        value: 'student.name',
        width: '40%',
        align: 'center',
      },
      { text: 'E-mail', value: 'student.email', width: '40%', align: 'center' },
      { text: 'Nota', value: 'grade', width: '20%', align: 'center' },
    ],
  }),
  async created() {
    if (!this.onlyView) {
      await this.readAllAppliedTests(this.test.id)
      this.statisticMode = true
    }
  },
  async beforeMount() {
    /*
    A resposta do usuário é salva dentro da propria pergunta, no objeto activeTest
    para V-F e Multipla escolha multi-respostas

    activeTest.questions[indice da pergunta].answers
    answers: {text:"alternativa", userAnswer: ""}

    na dissertativa, multipla escolha ->  é salva em:
    activeTest.questions[indice da pergunta].userAnswer
    */
    this.activeTest = JSON.parse(JSON.stringify(this.test))
    this.activeTest.questions.forEach((element, index) => {
      if (element.questionType !== 'dissertation') {
        element.answers = element.correctAnswers.concat(element.incorrectAnswers)
        element.answers.forEach((item) => {
          item = Object.assign(item, { userAnswer: '' })
        })
        element.userAnswer = ''

        // carregar gabarito correto
        if (element.questionType == 'objective') {
          const correct = this.searchCorrectAnswer(element._id, 'objective')
          element.userAnswer = correct
        }

        if (element.questionType == 'summation') {
          const correct = this.searchCorrectAnswer(element._id, 'summation')

          element.answers.forEach((item, index) => {
            correct.forEach((verify) => {
              if (item._id == verify._id) item.userAnswer = true
            })
            if (!element.userAnswer) element.userAnswer = 0
            if (item.userAnswer == true)
              element.userAnswer = Number(Math.pow(2, index)) + Number(element.userAnswer)
          })
        }

        if (element.questionType == 'multipleChoice') {
          const correct = this.searchCorrectAnswer(element._id, 'multipleChoice')

          element.answers.forEach((item) => {
            correct.forEach((verify) => {
              if (item._id == verify._id) item.userAnswer = true
            })
          })
        }

        if (element.questionType == 'trueOrFalse') {
          const correct = this.searchCorrectAnswer(element._id, 'trueOrFalse')

          element.answers.forEach((item) => {
            correct.forEach((verify) => {
              if (item._id == verify._id) {
                item.userAnswer = true
              } else {
                item.userAnswer = false
              }
            })
          })
        }
        //fim carrega gabarito correto
      } else {
        element.userAnswer = ''
        // carregar gabarito correto
        if (element.questionType == 'dissertation') {
          const correct = this.searchCorrectAnswer(element._id, 'dissertation')
          correct.forEach((correctAnswers, index) => {
            element.userAnswer += correct[0].text
            if (index > 0) element.userAnswer += ' / '
          })
        }
        //fim carregar gabarito correto
      }
      this.gabarito = JSON.parse(JSON.stringify(this.activeTest))
    })
  },

  watch: {
    selectedClass() {
      this.viewClassesTests.forEach((turma) => {
        if (turma.id == this.selectedClass) this.students = turma.students
      })
      this.selectedClassLength = this.students.length
      let noBlankStudents = this.students.filter((student) => student !== null)
      this.students = noBlankStudents

      //calcula nota dos estudantes
      this.students.forEach((student) => {
        this.generateGrade(student)
      })
      this.averageGrade()
      this.maxGrade()
      this.minGrade()

      //ao trocar de classe
      this.statisticMode = true
      this.analysisStudent = { idTest: '', answers: [], info: '', grade: '' }
    },

    'analysisStudent.idTest'() {
      if (this.analysisStudent.idTest) this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        if (this.analysisStudent.idTest) {
          this.activeGabarito = false

          this.students.forEach((student) => {
            if (student.id == this.analysisStudent.idTest) {
              this.analysisStudent.answers = student.answers
              this.analysisStudent.info = student.student
              this.analysisStudent.grade = student.grade
            }
          })
          this.refreshStudentAnswers()
          this.activeQuestion = 0

          //recarregar as perguntas
          this.$store.commit('user/UPDATE_LOADING', false)
          this.statisticMode = false
        }
      }, 200)
    },

    activeQuestion() {
      if (this.statisticMode) {
        this.$store.commit('user/UPDATE_LOADING', true)
        setTimeout(() => {
          this.statisticMode = false
          this.$store.commit('user/UPDATE_LOADING', false)
        }, 100)
      }
    },
  },

  methods: {
    handleClose() {
      this.$emit('handleClose')
    },

    // o professor ao clicar consegue ver as respostas enviadas pelo aluno
    refreshStudentAnswers() {
      this.activeTest.questions.forEach((element, index) => {
        element.userAnswer = ''

        this.analysisStudent.answers.forEach((studentAnswer) => {
          if (element._id == studentAnswer._id) {
            //substitui as respostas

            if (
              studentAnswer.questionType == 'trueOrFalse' ||
              studentAnswer.questionType == 'multipleChoice' ||
              studentAnswer.questionType == 'summation'
            ) {
              //limpa resultados antigos
              this.activeTest.questions[index].answers.forEach((old) => (old.userAnswer = false))

              //marca as opções do usuário
              studentAnswer.answers.forEach((item) => {
                this.activeTest.questions[index].answers.forEach((old, index2) => {
                  if (old._id == item._id) {
                    //atualiza opção do usuário
                    old.userAnswer = true

                    //se for somatório atualizar o valor da resposta
                    if (studentAnswer.questionType == 'summation') {
                      this.activeTest.questions[index].userAnswer =
                        Number(Math.pow(2, index2)) +
                        Number(this.activeTest.questions[index].userAnswer)
                    }
                  }
                })
              })
            }

            if (
              studentAnswer.questionType == 'objective' ||
              studentAnswer.questionType == 'dissertation'
            ) {
              this.activeTest.questions[index].userAnswer = studentAnswer.answers[0].text
            }
          }
        })
      })
    },

    // métodos para PROVA
    shuffleArray(array) {
      for (let i = array.length - 1; i > 0; i--) {
        const j = Math.floor(Math.random() * (i + 1))
        ;[array[i], array[j]] = [array[j], array[i]]
      }
    },

    searchCorrectAnswer(id, type) {
      let correct
      this.test.questions.forEach((question) => {
        if (question._id == id) {
          //encontrando gabarito de questão objetiva
          if (type == 'objective') {
            correct = question.correctAnswers[0].text
          }
          if (
            type == 'summation' ||
            type == 'multipleChoice' ||
            type == 'trueOrFalse' ||
            type == 'dissertation'
          ) {
            correct = question.correctAnswers
          }
        }
      })
      return correct
    },

    //mostra gabarito
    showRightAnswers() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.activeGabarito = true
        this.analysisStudent = { idTest: '', answers: [], info: '', grade: '' }
        this.activeQuestion = 0
        this.activeTest = JSON.parse(JSON.stringify(this.gabarito))
        this.$store.commit('user/UPDATE_LOADING', false)
        this.statisticMode = false
      }, 200)
    },

    showStatistics() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.statisticMode = true
        this.activeTest = JSON.parse(JSON.stringify(this.gabarito))
        this.analysisStudent = { idTest: '', answers: [], info: '' }
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 200)
    },

    // verifica se o usuário marcou a questão -> para  mostrar icone de certo ou errado
    verifyIcon(answer, idQuestion) {
      let check = false
      this.activeTest.questions.forEach((question) => {
        if (question._id == idQuestion) {
          //verifica multipla escolha simples
          if (question.questionType == 'objective') {
            if (answer == question.userAnswer) check = true
          }

          //verifica multipleChoice,summation
          if (question.questionType == 'multipleChoice' || question.questionType == 'summation') {
            question.answers.forEach((verifyEachAnswer) => {
              if (verifyEachAnswer.text == answer && verifyEachAnswer.userAnswer == true)
                check = true
            })
          }

          //verifica trueOrFalse
          if (question.questionType == 'trueOrFalse') {
            question.answers.forEach((verifyEachAnswer) => {
              if (verifyEachAnswer.text == answer) check = true
            })
          }
        }
      })
      return check
    },

    showIcons(answer, userAnswer, id, type) {
      let check = false
      this.test.questions.forEach((question) => {
        if (question._id == id) {
          //encontrando gabarito de questão objetiva
          if (type == 'dissertation') {
            question.correctAnswers.forEach((item) => {
              if (userAnswer == item.text) check = true
            })
          }

          if (type == 'objective') {
            if (answer == userAnswer && userAnswer == question.correctAnswers[0].text) check = true
          }

          if (type == 'summation' || type == 'multipleChoice') {
            question.correctAnswers.forEach((item) => {
              if (item._id == answer._id && userAnswer) check = true
            })
          }

          if (type == 'trueOrFalse') {
            question.incorrectAnswers.forEach((item) => {
              if (item._id == answer._id && !userAnswer) check = true
            })
            question.correctAnswers.forEach((item) => {
              if (item._id == answer._id && userAnswer) check = true
            })
          }
        }
      })
      return check
    },

    showSummation(value, operation, question) {
      let valor = Number(value)

      if (!question.userAnswer) question.userAnswer = Number(0)

      if (operation == true) {
        question.userAnswer = Number(question.userAnswer) + Number(valor)
      } else {
        question.userAnswer = Number(question.userAnswer) - Number(valor)
      }
    },

    generateGrade(student) {
      student.grade = 0
      let respostasAluno = student.answers // respostas enviada pelo aluno
      let gabarito = this.gabarito.questions // cada pergunta contém -> array de correctAnswers e incorrectAnswers

      //1º passo achar questão na array de gabarito
      respostasAluno.forEach((resposta) => {
        gabarito.forEach((gabaritoResposta) => {
          if (resposta._id == gabaritoResposta._id) {
            //2º passo - achou pergunta correspondente, agora calcular nota obtida na questão
            let numeroCorretas = gabaritoResposta.correctAnswers.length
            let corretasAluno = 0
            let incorretasAluno = 0
            resposta.grade = 0

            resposta.answers.forEach((respostaEnviada) => {
              //3º passo - verifica se resposta enviada pelo aluno, está lista de respostas corretas do gabarito
              gabaritoResposta.correctAnswers.forEach((respostaCorreta) => {
                if (
                  resposta.questionType !== 'dissertation' &&
                  respostaEnviada._id == respostaCorreta._id
                ) {
                  corretasAluno++
                }

                if (
                  resposta.questionType == 'dissertation' &&
                  respostaEnviada.text == respostaCorreta.text
                ) {
                  corretasAluno = numeroCorretas
                }
              })

              //4º passo - verifica se resposta enviada pelo aluno, está lista de respostas incorretas do gabarito
              gabaritoResposta.incorrectAnswers.forEach((respostaIncorreta) => {
                if (
                  resposta.questionType !== 'dissertation' &&
                  respostaEnviada._id == respostaIncorreta._id
                ) {
                  incorretasAluno++
                }
              })

              //5º verifica pontuação obtida na questão

              //acertou tudo
              if (corretasAluno - incorretasAluno == numeroCorretas)
                resposta.grade = resposta.weight

              //proporcional
              if (
                corretasAluno - incorretasAluno < numeroCorretas &&
                corretasAluno - incorretasAluno > 0
              ) {
                resposta.grade =
                  ((corretasAluno - incorretasAluno) / numeroCorretas).toFixed(3) * resposta.weight
              }

              //errou tudo
              if (incorretasAluno > corretasAluno || incorretasAluno == corretasAluno)
                resposta.grade = 0
            })
          }
        })

        //6ºcalcula nota final da prova
        student.grade += Number(resposta.grade)
      })
      return student.grade
    },

    //mostra nota obtida na questão
    showGradeAnswer(idTest, idQuestion) {
      for (let i = 0; i < this.students.length; i++) {
        if (idTest == this.students[i].id) {
          for (let x = 0; x < this.students[i].answers.length; x++) {
            if (idQuestion == this.students[i].answers[x]._id)
              return this.students[i].answers[x].grade
          }
        }
      }
      return 0
    },

    averageGrade() {
      let sumGrades = 0
      this.students.forEach((student) => {
        sumGrades += Number(student.grade)
      })

      this.classGrade.average = (sumGrades / this.students.length).toFixed(2)
    },

    maxGrade() {
      let maxGrade = -1
      this.students.forEach((student) => {
        if (student.grade > maxGrade) maxGrade = student.grade
      })
      this.classGrade.max = maxGrade
    },

    minGrade() {
      let minGrade = 10000
      this.students.forEach((student) => {
        if (student.grade < minGrade) minGrade = student.grade
      })
      this.classGrade.min = minGrade
    },

    async readAllAppliedTests(testId) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.readAllAppliedTests(testId)
        if (req.success) {
          this.viewClassesTests = req.data.test.class
          this.viewClassesTests.forEach((item, index) => {
            if (item._id == this.classes[index]._id) item.name = this.classes[index].name
          })
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.testStyle {
  background: white;
  height: 100vh;
  width: 100%;
  display: block;
  align-content: flex-start;
}

.topBar {
  display: flex;
  width: 100%;
  height: 64px;
  align-items: center;
  -webkit-box-shadow: 0px 3px 7px 0px rgba(50, 50, 50, 0.35);
  -moz-box-shadow: 0px 3px 7px 0px rgba(50, 50, 50, 0.35);
  box-shadow: 0px 3px 7px 0px rgba(50, 50, 50, 0.35);
}

.contentTopBar {
  display: flex;
  height: 1.6rem;
  align-items: center;
  margin-left: 68px;
}

.contentStyleTest {
  display: flex;
  min-height: calc(100% - 64px);
  /* min-height: 100%; */
  background: white;
}

.leftStyle {
  width: 256px;
  min-height: 100%;
  border-right: 1px solid rgba(50, 50, 50, 0.15);
  padding-top: 24px;
}

.rightStyle {
  width: calc(100% - 256px);
  padding-top: 24px;
}

.spanStyle > span {
  padding-right: 24px;
}

@media all and (max-width: 800px) {
  .leftStyle {
    display: none;
    height: 100%;
  }
  .rightStyle {
    width: 100%;
    height: 100%;
    padding-top: 24px;
  }
}
</style>
